/**
 * BingoProgressionクラス
 * 1から75までの数字をランダムにもれなくだぶりなく持つ数列（ビンゴ数列）を持つ。
 * ビンゴ数列表示する。を取得するためのメソッドを持つ。
 * @author Hirata Atsushi
 */
 
import java.util.*;

class BingoProgression implements Iterator{
 
  static final int     BINGO_MAX_NUMBER         = 75;
  
  private ArrayList <Integer> bingoProgression
          = new ArrayList<Integer>();
  private int currentIndex = 0;
  
  public BingoProgression(){
    createBingoProgression(bingoProgression);    
  }

// Iteratorインタフェイスの実装
  public boolean hasNext(){
    if (currentIndex < BINGO_MAX_NUMBER) {
      return true;
    } else {
      return false;
    }
  }
  
  public Integer next(){
    if (currentIndex < BINGO_MAX_NUMBER) {
      Integer val = bingoProgression.get(currentIndex);
      currentIndex++;
      return val;
    } else {
      throw new NoSuchElementException();
    }
  }
  
  public void remove(){
    //今の所値削除機能のサポートの予定なし
    throw new UnsupportedOperationException();
  }
}

//各種メソッド
private void createBingoProgression(ArrayList v){
  println("class BingoProgression.createBingoProgression called.");
  ArrayList <Integer> temp = new ArrayList<Integer>();
  for(int i = 1; i <= BINGO_MAX_NUMBER; i++){
    temp.add(i);
  }
  while( temp.size() > 0 ){
    int i = (int) (Math.random() * 100 + 1) % temp.size();
    v.add(
      temp.get(i)
    );
    temp.remove(i);
    println("Bingo Progression ["+(v.size()-1)+"] = "
            + v.get( v.size()-1 ) );
  } 
  println("class BingoProgression.createBingoProgression finished.");
}